# TODO:
#
# - support for miniupnpc

Name:           bitcoin
Version:        0.5.0
Release:        1%{?dist}
Summary:        A peer-to-peer electronic crypto-currency cash system
Group:          Applications/Internet
License:        MIT
URL:            http://bitcoin.org/

Source0:        bitcoin-bitcoin-v0.5.0-0-gf53c5ed.tar.gz

# bitcoin needs to rebuild OpenSSL with ECC support https://bitcointalk.org/index.php?topic=9476.0
#Source1:       openssl-1.0.0e-usa.tar.bz2
Source1:        http://www.openssl.org/source/openssl-1.0.0e.tar.gz
Source2:        bitcoin-makefile.fedora
Source3:        bitcoin-README.Fedora
Source4:        bitcoin-qt.pro

BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-buildroot

BuildRequires:  db4-devel, boost-devel, gcc-c++
#BuildRequires: miniupnpc-devel

BuildRequires:  desktop-file-utils qt-devel

#openssl build requirements:
BuildRequires:  mktemp, krb5-devel, perl, sed, zlib-devel, /usr/bin/cmp
BuildRequires:  /usr/bin/rename


Requires:       desktop-file-utils

%description

Bitcoin is a free open source peer-to-peer electronic cash system that is
completely decentralized, without the need for a central server or trusted
parties.  Users hold the crypto keys to their own money and transact directly
with each other, with the help of a P2P network to check for double-spending.

See the documentation at the bitcoin wiki:
  https://en.bitcoin.it/wiki/Main_Page
for help and more information.


%prep
%setup -q -n bitcoin-bitcoin-664057f

# use miniupnpc
#USE_UPNP=1

### building openssl as a bitcoin prep:

tar zxvf %{SOURCE1}
pushd  openssl-1.0.0e
./Configure --prefix=%{buildroot}-openssl-bin/ \
        --openssldir=%{buildroot}-openssl-bin/openssldir/ \
        linux-elf
make && make install
popd # exiting openssl dir

### bitcoin preparation:

cp %{SOURCE2} src/makefile.rpmfusion
sed -i 's|OPENSSL|%{buildroot}-openssl-bin|g' src/makefile.rpmfusion

cp %{SOURCE4} bitcoin-qt.pro


%build

# bitcoind build:
pushd src/
make -f makefile.rpmfusion
popd

# bitcoin-qt build:
#     qmake "USE_UPNP=1"
qmake-qt4 "USE_UPNP=-" "USE_DBUS=1"  BOOST_LIB_SUFFIX=-mt \
        OPENSSL_INCLUDE_PATH=%{buildroot}-openssl-bin/include \
        OPENSSL_LIB_PATH=%{buildroot}-openssl-bin/lib
make


%install
rm -rf %{buildroot}

install -D -p src/bitcoind %{buildroot}/%{_libexecdir}/bitcoin/bitcoind
install -D -p bitcoin-qt %{buildroot}/%{_libexecdir}/bitcoin/bitcoin-qt

install -d %{buildroot}/%{_bindir}
sed "s|/usr/lib/bitcoin|%{_libexecdir}/bitcoin|g"  < contrib/debian/bin/bitcoind > %{buildroot}/%{_bindir}/bitcoind
sed "s|/usr/lib/bitcoin|%{_libexecdir}/bitcoin|g"  < contrib/debian/bin/bitcoin-qt > %{buildroot}/%{_bindir}/bitcoin-qt

chmod 755 %{buildroot}/%{_bindir}/bitcoind
chmod 755 %{buildroot}/%{_bindir}/bitcoin-qt

install -m 644 -D -p src/qt/res/src/bitcoin.svg %{buildroot}%{_datadir}/icons/hicolor/scalable/apps/bitcoin.svg

sed -i "s|/usr/share/pixmaps/bitcoin80.xpm|bitcoin|g" contrib/debian/bitcoin-qt.desktop
desktop-file-install contrib/debian/bitcoin-qt.desktop \
        --add-category=Network \
        --dir %{buildroot}%{_datadir}/applications 

install -pD -m 644 contrib/debian/manpages/bitcoind.1 %{buildroot}/%{_mandir}/man1/bitcoind.1
install -pD -m 644 contrib/debian/manpages/bitcoin.conf.5 %{buildroot}/%{_mandir}/man5/bitcoin.conf.5

cp %{SOURCE3} README.Fedora

%clean
rm -rf %{buildroot}
rm -rf %{buildroot}-openssl-bin

%post
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :
update-desktop-database &> /dev/null || :

%postun
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi
update-desktop-database &> /dev/null || :

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files
%defattr(-,root,root,0755)
%doc COPYING README.md README.Fedora contrib/debian/examples/
%{_bindir}/*
%{_libexecdir}/*
%{_mandir}/man5/*
%{_mandir}/man1/*
%{_datadir}/applications/%{name}-qt.desktop
%{_datadir}/icons/hicolor/scalable/apps/%{name}.svg

%changelog
* Wed Dec 7 2011 <ismael@olea.org> - 0.5.0-1
- first release

